﻿using System.Text;
using System.Text.Json;
using Amazon.Lambda;
using Amazon.Lambda.Model;

AmazonLambdaClient client = new AmazonLambdaClient();

if (args.Length != 2)
{
    Console.WriteLine("Usage: dotnet run FunctionName WarmUpString");
    return;
}
string functionName = args[0];
string warmUpString = args[1];
Console.WriteLine($"Invoking {functionName}...");

List<Task<InvokeResponse>> taskList = new List<Task<InvokeResponse>>();
for (int i = 1; i <= 100; i++)
{
    Console.WriteLine($"Invoking {i}");
    var request = new InvokeRequest
    {
        FunctionName = functionName,
        Payload = JsonSerializer.Serialize(warmUpString),
        LogType = LogType.Tail
    };
    taskList.Add(client.InvokeAsync(request));
}

await Task.WhenAll(taskList);

foreach (var task in taskList)
{
    var response = await task;
    Console.WriteLine(JsonSerializer.Deserialize<string>(response.Payload));
    var log = Encoding.UTF8.GetString(Convert.FromBase64String(response.LogResult));
    Console.WriteLine(log);
}